function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import hoistStatics from 'hoist-non-react-statics';
import getInitialProps from '../util/getInitialProps';
import getDisplayName from '../util/getDisplayName';
/**
 * inject Layout
 * @param {Component} Layout
 */

const withLayout = Layout => BaseComponent => {
  const InjectLayout = props => {
    return React.createElement(Layout, props, React.createElement(BaseComponent, props));
  }; // wrap displayName for easier debug


  InjectLayout.displayName = `withLayout(${getDisplayName(BaseComponent)})`;

  InjectLayout.getInitialProps = async context => {
    const props = await getInitialProps(BaseComponent, context); // Get menu info

    const {
      pathname
    } = context; // get title from pathname

    let title;

    if (pathname && pathname !== '') {
      [title] = pathname.split('/').reverse(); // title = pathname.slice(pathname.lastIndexOf('/') + 1);
    }

    return _objectSpread({}, props, {
      title
    });
  }; // hoist all static functions


  hoistStatics(InjectLayout, BaseComponent);
  return InjectLayout;
};

export default withLayout;